org.codehaus.plexus.util.xml

## Class Xpp3Dom

- java.lang.Object
- - org.codehaus.plexus.util.xml.Xpp3Dom

-     public class Xpp3Dom
      extends java.lang.Object

  Version:
    $Id: Xpp3Dom.java 8215 2009-05-24 16:32:26Z bentmann $ NOTE: remove all the util code in here when separated, this class should be pure data.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.Map` | `attributes`
    `protected java.util.List` | `childList`
    `protected java.util.Map` | `childMap`
    `static java.lang.String` | `CHILDREN_COMBINATION_APPEND`
    `static java.lang.String` | `CHILDREN_COMBINATION_MERGE`
    `static java.lang.String` | `CHILDREN_COMBINATION_MODE_ATTRIBUTE`
    `static java.lang.String` | `DEFAULT_CHILDREN_COMBINATION_MODE` This default mode for combining children DOMs during merge means that where element names match, the process will try to merge the element data, rather than putting the dominant and recessive elements (which share the same element name) as siblings in the resulting DOM.
    `static java.lang.String` | `DEFAULT_SELF_COMBINATION_MODE` This default mode for combining a DOM node during merge means that where element names match, the process will try to merge the element attributes and values, rather than overriding the recessive element completely with the dominant one.
    `protected java.lang.String` | `name`
    `protected Xpp3Dom` | `parent`
    `static java.lang.String` | `SELF_COMBINATION_MERGE`
    `static java.lang.String` | `SELF_COMBINATION_MODE_ATTRIBUTE`
    `static java.lang.String` | `SELF_COMBINATION_OVERRIDE`
    `protected java.lang.String` | `value`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Xpp3Dom(java.lang.String name)`
    `Xpp3Dom(Xpp3Dom src)` Copy constructor.
    `Xpp3Dom(Xpp3Dom src, java.lang.String name)` Copy constructor with alternative name.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addChild(Xpp3Dom xpp3Dom)`
    `boolean` | `equals(java.lang.Object obj)`
    `java.lang.String` | `getAttribute(java.lang.String name)`
    `java.lang.String[]` | `getAttributeNames()`
    `Xpp3Dom` | `getChild(int i)`
    `Xpp3Dom` | `getChild(java.lang.String name)`
    `int` | `getChildCount()`
    `Xpp3Dom[]` | `getChildren()`
    `Xpp3Dom[]` | `getChildren(java.lang.String name)`
    `java.lang.String` | `getName()`
    `Xpp3Dom` | `getParent()`
    `java.lang.String` | `getValue()`
    `int` | `hashCode()`
    `static boolean` | `isEmpty(java.lang.String str)`
    `static boolean` | `isNotEmpty(java.lang.String str)`
    `static Xpp3Dom` | `mergeXpp3Dom(Xpp3Dom dominant, Xpp3Dom recessive)` Merge two DOMs, with one having dominance in the case of collision.
    `static Xpp3Dom` | `mergeXpp3Dom(Xpp3Dom dominant, Xpp3Dom recessive, java.lang.Boolean childMergeOverride)` Merge two DOMs, with one having dominance in the case of collision.
    `void` | `removeChild(int i)`
    `void` | `setAttribute(java.lang.String name, java.lang.String value)` Set the attribute value
    `void` | `setParent(Xpp3Dom parent)`
    `void` | `setValue(java.lang.String value)`
    `java.lang.String` | `toString()`
    `java.lang.String` | `toUnescapedString()`
    `void` | `writeToSerializer(java.lang.String namespace, XmlSerializer serializer)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### name

          protected java.lang.String name

    - #### value

          protected java.lang.String value

    - #### attributes

          protected java.util.Map attributes

    - #### childList

          protected final java.util.List childList

    - #### childMap

          protected final java.util.Map childMap

    - #### parent

          protected Xpp3Dom parent

    - #### CHILDREN_COMBINATION_MODE_ATTRIBUTE

          public static final java.lang.String CHILDREN_COMBINATION_MODE_ATTRIBUTE

      See Also:
        Constant Field Values

    - #### CHILDREN_COMBINATION_MERGE

          public static final java.lang.String CHILDREN_COMBINATION_MERGE

      See Also:
        Constant Field Values

    - #### CHILDREN_COMBINATION_APPEND

          public static final java.lang.String CHILDREN_COMBINATION_APPEND

      See Also:
        Constant Field Values

    - #### DEFAULT_CHILDREN_COMBINATION_MODE

          public static final java.lang.String DEFAULT_CHILDREN_COMBINATION_MODE

      This default mode for combining children DOMs during merge means that where element names match, the process will try to merge the element data, rather than putting the dominant and recessive elements (which share the same element name) as siblings in the resulting DOM.
      See Also:
        Constant Field Values

    - #### SELF_COMBINATION_MODE_ATTRIBUTE

          public static final java.lang.String SELF_COMBINATION_MODE_ATTRIBUTE

      See Also:
        Constant Field Values

    - #### SELF_COMBINATION_OVERRIDE

          public static final java.lang.String SELF_COMBINATION_OVERRIDE

      See Also:
        Constant Field Values

    - #### SELF_COMBINATION_MERGE

          public static final java.lang.String SELF_COMBINATION_MERGE

      See Also:
        Constant Field Values

    - #### DEFAULT_SELF_COMBINATION_MODE

          public static final java.lang.String DEFAULT_SELF_COMBINATION_MODE

      This default mode for combining a DOM node during merge means that where element names match, the process will try to merge the element attributes and values, rather than overriding the recessive element completely with the dominant one. This means that wherever the dominant element doesn't provide the value or a particular attribute, that value or attribute will be set from the recessive DOM node.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Xpp3Dom

          public Xpp3Dom(java.lang.String name)

    - #### Xpp3Dom

          public Xpp3Dom(Xpp3Dom src)

      Copy constructor.

    - #### Xpp3Dom

          public Xpp3Dom(Xpp3Dom src,
                         java.lang.String name)

      Copy constructor with alternative name.

  - ### Method Detail

    - #### getName

          public java.lang.String getName()

    - #### getValue

          public java.lang.String getValue()

    - #### setValue

          public void setValue(java.lang.String value)

    - #### getAttributeNames

          public java.lang.String[] getAttributeNames()

    - #### getAttribute

          public java.lang.String getAttribute(java.lang.String name)

    - #### setAttribute

          public void setAttribute(java.lang.String name,
                                   java.lang.String value)

      Set the attribute value
      Parameters:
        `name` - String not null
        `value` - String not null

    - #### getChild

          public Xpp3Dom getChild(int i)

    - #### getChild

          public Xpp3Dom getChild(java.lang.String name)

    - #### addChild

          public void addChild(Xpp3Dom xpp3Dom)

    - #### getChildren

          public Xpp3Dom[] getChildren()

    - #### getChildren

          public Xpp3Dom[] getChildren(java.lang.String name)

    - #### getChildCount

          public int getChildCount()

    - #### removeChild

          public void removeChild(int i)

    - #### getParent

          public Xpp3Dom getParent()

    - #### setParent

          public void setParent(Xpp3Dom parent)

    - #### writeToSerializer

          public void writeToSerializer(java.lang.String namespace,
                                        XmlSerializer serializer)
                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### mergeXpp3Dom

          public static Xpp3Dom mergeXpp3Dom(Xpp3Dom dominant,
                                             Xpp3Dom recessive,
                                             java.lang.Boolean childMergeOverride)

      Merge two DOMs, with one having dominance in the case of collision.
      Parameters:
        `dominant` - The dominant DOM into which the recessive value/attributes/children will be merged
        `recessive` - The recessive DOM, which will be merged into the dominant DOM
        `childMergeOverride` - Overrides attribute flags to force merging or appending of child elements into the dominant DOM
      See Also:
        `CHILDREN_COMBINATION_MODE_ATTRIBUTE`, `SELF_COMBINATION_MODE_ATTRIBUTE`

    - #### mergeXpp3Dom

          public static Xpp3Dom mergeXpp3Dom(Xpp3Dom dominant,
                                             Xpp3Dom recessive)

      Merge two DOMs, with one having dominance in the case of collision. Merge mechanisms (vs. override for nodes, or vs. append for children) is determined by attributes of the dominant root node.
      Parameters:
        `dominant` - The dominant DOM into which the recessive value/attributes/children will be merged
        `recessive` - The recessive DOM, which will be merged into the dominant DOM
      See Also:
        `CHILDREN_COMBINATION_MODE_ATTRIBUTE`, `SELF_COMBINATION_MODE_ATTRIBUTE`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### toUnescapedString

          public java.lang.String toUnescapedString()

    - #### isNotEmpty

          public static boolean isNotEmpty(java.lang.String str)

    - #### isEmpty

          public static boolean isEmpty(java.lang.String str)